import { Message } from "eris";
import { LoggerInstance } from "winston";
import Configuration from "../Configuration";
import CommandContext from "./CommandContext";
import CommandHelper from "./CommandHelper";
import CommandInterface from "./CommandInterface";
import MessageInterface from "./MessageInterface";
export default abstract class AbstractCommand implements CommandInterface {
    protected context: CommandContext;
    protected commandHelper: CommandHelper;
    protected configuration: Configuration;
    protected logger: LoggerInstance;
    setContext(context: CommandContext): CommandInterface;
    abstract process(message?: any): Promise<void>;
    protected reply(content: any): Promise<MessageInterface>;
    protected getMessage(message: any): Promise<Message>;
    protected deleteMessage(message: any): Promise<void>;
    protected editMessage(message: any, content: any): Promise<Message>;
    protected sendMessage(channel: string | any, content: any): Promise<MessageInterface>;
    protected reactOk(): Promise<void>;
    protected reactNotOk(): Promise<void>;
    protected embedMessage(callback: (x: any) => any): Promise<MessageInterface>;
    protected log(level: any, msg: any, ...meta: any[]): void;
    protected debug(msg: any, ...meta: any[]): void;
}
