"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const moment = require("moment");
const types_1 = require("../types");
const CommandHelper_1 = require("./CommandHelper");
let AbstractCommand = class AbstractCommand {
    setContext(context) {
        this.context = context;
        this.commandHelper.context = context;
        return this;
    }
    reply(content) {
        return this.sendMessage(this.context.message.channel.id, content);
    }
    getMessage(message) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.commandHelper.getMessage(message);
        });
    }
    deleteMessage(message) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.commandHelper.deleteMessage(message);
        });
    }
    editMessage(message, content) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.commandHelper.editMessage(message, content);
        });
    }
    sendMessage(channel, content) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.commandHelper.sendMessage(channel, content);
        });
    }
    reactOk() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.commandHelper.react("👍🏻");
        });
    }
    reactNotOk() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.commandHelper.react("👎🏻");
        });
    }
    embedMessage(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const embed = {
                author: {
                    icon_url: this.configuration.user.avatarURL,
                    name: this.configuration.user.username,
                },
                color: 0x428BCA,
                fields: [],
                timestamp: moment().utc().toDate(),
            };
            callback(embed);
            return yield this.reply({ embed });
        });
    }
    log(level, msg, ...meta) {
        this.logger.log(level, msg, ...meta);
    }
    debug(msg, ...meta) {
        this.logger.debug(msg, ...meta);
    }
};
__decorate([
    inversify_1.inject(types_1.default.Command.Helper),
    __metadata("design:type", CommandHelper_1.default)
], AbstractCommand.prototype, "commandHelper", void 0);
__decorate([
    inversify_1.inject(types_1.default.Configuration),
    __metadata("design:type", Object)
], AbstractCommand.prototype, "configuration", void 0);
__decorate([
    inversify_1.inject(types_1.default.Logger),
    __metadata("design:type", Object)
], AbstractCommand.prototype, "logger", void 0);
AbstractCommand = __decorate([
    inversify_1.injectable()
], AbstractCommand);
exports.default = AbstractCommand;
//# sourceMappingURL=AbstractCommand.js.map