"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const CommandInfoFactory_1 = require("../Factory/CommandInfoFactory");
const Kernel_1 = require("../Kernel");
const types_1 = require("../types");
const CommandContext_1 = require("./CommandContext");
let CommandHandler = class CommandHandler {
    constructor(kernel) {
        this.kernel = kernel;
        this.container = kernel.container;
        this.kernel.on("ready", () => {
            this.gateways.forEach((gateway) => {
                gateway.on("executeCommand", this.handleCommand.bind(this, gateway));
            });
        });
    }
    handleCommand(gateway, message, commandData, ack) {
        return __awaiter(this, void 0, void 0, function* () {
            const command = this.findCommand(commandData);
            if (!command) {
                return;
            }
            command.setContext(new CommandContext_1.default(message, gateway));
            const parameters = [];
            const metadata = Reflect.getMetadata("command", command);
            for (const key in metadata.parameters) {
                if (!metadata.parameters.hasOwnProperty(key)) {
                    continue;
                }
                parameters.push(commandData.parameters[key].value !== undefined
                    ? commandData.parameters[key].value
                    : metadata.parameters[key].defaultValue);
            }
            yield command.process(...parameters);
            ack(true);
        });
    }
    findCommand(commandData) {
        return this.container.getNamed(types_1.default.Command.Interface, commandData.aliases[0]);
    }
};
__decorate([
    inversify_1.inject(types_1.default.Factory.Info),
    __metadata("design:type", CommandInfoFactory_1.default)
], CommandHandler.prototype, "infoFactory", void 0);
__decorate([
    inversify_1.multiInject(types_1.default.Gateway),
    __metadata("design:type", Array)
], CommandHandler.prototype, "gateways", void 0);
CommandHandler = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject(types_1.default.Kernel)),
    __metadata("design:paramtypes", [Kernel_1.default])
], CommandHandler);
exports.default = CommandHandler;
//# sourceMappingURL=CommandHandler.js.map