"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const Gateway_1 = require("../Gateway");
const types_1 = require("../types");
let CommandHelper = class CommandHelper {
    get messageService() {
        return this.context.gateway.app.service("message");
    }
    get restApp() {
        return this.context.gateway.app.service("rest");
    }
    getMessage(message) {
        return new Promise((resolve, reject) => {
            this.messageService.get(message.id, { query: { channel: message.channel.id } }).then(resolve).catch(reject);
        });
    }
    deleteMessage(message) {
        return new Promise((resolve, reject) => {
            this.messageService.remove(message.id, { query: { channel: message.channel.id } }).then(resolve).catch(reject);
        });
    }
    editMessage(message, content) {
        return new Promise((resolve, reject) => {
            this.messageService.update(message.id, { content }, { query: { channel: message.channel.id } }).then(resolve).catch(reject);
        });
    }
    sendMessage(channel, content) {
        return new Promise((resolve, reject) => {
            this.messageService.create(typeof content === "string" ? { content } : content, { query: { channel: channel.id || channel } }).then(resolve).catch(reject);
        });
    }
    react(reaction, messageId, channelId) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.rest("addMessageReaction", channelId || this.context.channel.id, messageId || this.context.message.id, reaction);
        });
    }
    rest(method, ...args) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.restApp.get(method, { args });
        });
    }
};
__decorate([
    inversify_1.inject(types_1.default.Gateway), inversify_1.tagged("rest", true),
    __metadata("design:type", Gateway_1.default)
], CommandHelper.prototype, "restGateway", void 0);
CommandHelper = __decorate([
    inversify_1.injectable()
], CommandHelper);
exports.default = CommandHelper;
//# sourceMappingURL=CommandHelper.js.map