import CommandInterface from "./CommandInterface";
import { ExecutionContext } from "./MetadataInterface";
import Parameter from "./Parameter";
import RequirementInterface from "./RequirementInterface";
export default class CommandInfo {
    readonly name: string;
    module: string;
    aliases: string[];
    shortDescription?: string;
    longDescription?: string;
    syntax?: string;
    showInHelp: boolean;
    caseInsensitive: boolean;
    deleteCommand: boolean;
    context: ExecutionContext;
    parameters: Parameter[];
    requirements: RequirementInterface;
    constructor(command: CommandInterface);
    private buildSyntax();
}
