export interface Authentication {
    key: string;
}
export interface Gateway {
    name: string;
    events?: string[];
}
export interface Database {
    mysql?: Mysql;
}
export interface Mysql {
    host: string;
    port: number;
    username: string;
    password: string;
    database: string;
    entities: string[];
    autoSchemaSync: boolean;
}
export default interface Configuration {
    promPrefix?: string;
    auth: Authentication;
    gateways: string[];
    gateway: Gateway;
    database?: Database;
    user?: {
        avatarURL: string;
        username: string;
    };
}
