"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (name, module, shortDescription, longDescription) => {
    return (target) => {
        const metadata = Reflect.getMetadata("command", target) || {};
        if (Array.isArray(metadata.aliases)) {
            metadata.aliases.unshift(name);
        }
        else {
            metadata.aliases = [name];
        }
        metadata.module = module;
        metadata.shortDescription = shortDescription;
        metadata.longDescription = longDescription || shortDescription;
        Reflect.defineMetadata("command", metadata, target);
    };
};
//# sourceMappingURL=Command.js.map