"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const eventemitter3_1 = require("eventemitter3");
const inversify_1 = require("inversify");
const Gateway_1 = require("../Gateway");
const types_1 = require("../types");
const CommandInfoFactory_1 = require("./CommandInfoFactory");
let GatewayFactory = class GatewayFactory {
    constructor() {
        this.commands = [];
    }
    create(url) {
        const info = this.commands.map(this.infoFactory.getCommandInfo.bind(this.infoFactory));
        const config = {
            url,
            commands: info,
            name: this.configuration.gateway.name,
            events: this.configuration.gateway.events,
            auth: this.configuration.auth,
            promPrefix: this.configuration.promPrefix,
        };
        return new Gateway_1.default(this.eventEmitter, config);
    }
};
__decorate([
    inversify_1.inject(types_1.default.EventEmitter),
    __metadata("design:type", eventemitter3_1.EventEmitter)
], GatewayFactory.prototype, "eventEmitter", void 0);
__decorate([
    inversify_1.inject(types_1.default.Configuration),
    __metadata("design:type", Object)
], GatewayFactory.prototype, "configuration", void 0);
__decorate([
    inversify_1.multiInject(types_1.default.Command.Interface), inversify_1.optional(),
    __metadata("design:type", Array)
], GatewayFactory.prototype, "commands", void 0);
__decorate([
    inversify_1.inject(types_1.default.Factory.Info),
    __metadata("design:type", CommandInfoFactory_1.default)
], GatewayFactory.prototype, "infoFactory", void 0);
GatewayFactory = __decorate([
    inversify_1.injectable()
], GatewayFactory);
exports.default = GatewayFactory;
//# sourceMappingURL=GatewayFactory.js.map