import { EventEmitter } from "eventemitter3";
import * as feathers from "feathers/client";
import { Gauge } from "prom-client";
export interface GatewayConfig {
    name: string;
    commands: any[];
    url: string;
    events: string[];
    auth: {
        key: string;
    };
    promPrefix?: string;
}
export default class Gateway {
    private eventEmitter;
    private config;
    app: feathers.Application;
    connected: boolean;
    configuration: any;
    gauges: {
        [name: string]: Gauge;
    };
    private registry;
    private socket;
    private storage;
    private authenticating;
    private authenticated;
    private authToken;
    private reconnectInterval;
    constructor(eventEmitter: EventEmitter, config: GatewayConfig);
    authenticate(): Promise<{}>;
    addGauge(nick: string, help: string, labelNames?: string[]): void;
    emit(event: string, ...args: any[]): void;
    on(event: any, callback: (x: any) => any): void;
    private configure(callback?);
}
