"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const eventemitter3_1 = require("eventemitter3");
const ContainerBuilder_1 = require("./ContainerBuilder");
const types_1 = require("./types");
class Kernel extends eventemitter3_1.EventEmitter {
    constructor(config) {
        super();
        this.config = config;
        this.ready = false;
        this.config = config;
        this.on("gatewayConfigured", () => {
            const gateways = this.container.getAll(types_1.default.Gateway);
            if (!this.ready && gateways.filter((x) => !x.configuration).length === 0) {
                this.ready = true;
                this.emit("ready");
            }
        });
    }
    static create(config) {
        return __awaiter(this, void 0, void 0, function* () {
            const constructor = Kernel.prototype.constructor;
            const kernel = new constructor(config);
            yield kernel.initialize();
            return kernel;
        });
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            this.container = yield ContainerBuilder_1.ContainerBuilder.build(this, this.config);
            this.container.getAll(types_1.default.Gateway);
        });
    }
    addGauge(name, help, labelNames = []) {
        if (!this.ready) {
            throw new Error("Wait till after connecting to add gauges");
        }
        this.container.getAll(types_1.default.Gateway).forEach((x) => x.addGauge(name, help, labelNames));
    }
}
exports.default = Kernel;
//# sourceMappingURL=Kernel.js.map